#!/usr/bin/env python
#https://wiki.python.org/moin/TcpCommunication

import socket
import netifaces
import serial
import time
from threading import Thread

def szCurrentIP() :
        interfaces = netifaces.interfaces()
        for i in interfaces:
                if i == 'lo':
                        continue
                iface = netifaces.ifaddresses(i).get(netifaces.AF_INET)
                if iface != None:
                        for j in iface:
                                return j['addr']
def startServer( ip ) :

	rpiSerialPort = '/dev/ttyUSB0'
	ser = serial.Serial(rpiSerialPort,9600)
	ser.write("off")
	
        TCP_IP = ip
        print ("server in: ",TCP_IP)
        #TCP_IP = '127.0.0.1'
        TCP_PORT = 6005
        BUFFER_SIZE = 20  # Normally 1024, but we want fast response
        while 1:
                s = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
                s.bind((TCP_IP, TCP_PORT))
                s.listen(1)

                conn, addr = s.accept()
                print 'Connection address:', addr
                while 1:
		     data = conn.recv(BUFFER_SIZE)
		     if not data: break
		     print "received data:", data
		     conn.send(data)  # echo
		     ser.write(data)
		     time.sleep(0.1)
		ser.write("off")
		ser.close()

if __name__ == "__main__":
        nservers = netifaces.interfaces()
        for x in nservers:
                if x == 'lo':
                        continue
                iface = netifaces.ifaddresses(x).get(netifaces.AF_INET)
                if iface != None:
                        for j in iface:
                        	t = Thread(target=startServer, args=(j['addr'], ))
    				t.start()
                                print "Server in ", j['addr']


